/***********************************************************************************************************************
 *
 * SolidBlue - open source safe data
 * Copyright (C) 2011-2011 by Tidalwave s.a.s. (http://www.tidalwave.it)
 *
 ***********************************************************************************************************************
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License is distributed on
 * an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations under the License.
 *
 ***********************************************************************************************************************
 *
 * WWW: http://solidblue.java.net
 * SCM: https://bitbucket.org/tidalwave/solidblue-src
 *
 **********************************************************************************************************************/
package it.tidalwave.integritychecker.ui.impl.action;

import java.io.File;
import javax.annotation.Nonnull;
import java.awt.event.ActionEvent;
import org.openide.util.HelpCtx;
import org.openide.util.actions.SystemAction;
import org.openide.awt.ActionID;
import org.openide.awt.ActionReference;
import org.openide.awt.ActionReferences;
import org.openide.awt.ActionRegistration;
import it.tidalwave.integritychecker.FileScanRequestMessage;

/***********************************************************************************************************************
 * 
 * @author  Fabrizio Giudici
 * @version $Id$
 *
 **********************************************************************************************************************/
@ActionID(id = "it.tidalwave.integritychecker.ui.impl.action.ScanAction", category = "File")
@ActionRegistration(displayName = "#CTL_ScanAction", 
                    iconBase = "it/tidalwave/integritychecker/ui/impl/action/Button-go.png")
@ActionReferences(value = 
  {
    @ActionReference(path = "Menu/File", position = 2500),
    @ActionReference(path = "Toolbars/Standard", position = 2500)
  })
public final class ScanAction extends SystemAction
  {
    @Override
    public void actionPerformed (final @Nonnull ActionEvent event) 
      {
        final FileChooser fileChooser = new FileChooser() 
          {
            @Override
            protected void onFileSelected (final @Nonnull File file) 
              {
                FileScanRequestMessage.forFile(file).send();
              }
          };
        
        fileChooser.run(event);
      }

    @Override
    public String getName() 
      {
        return "scan";
      }

    @Override
    public HelpCtx getHelpCtx() 
      {
        return null;
      }
  }
